"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactFormsProcessor = require("react-forms-processor");

var _tabs = require("@atlaskit/tabs");

var _tabs2 = _interopRequireDefault(_tabs);

var _definitions = require("./definitions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getTabs = function getTabs(renderer) {
  return [{
    label: "Basics",
    content: _react2.default.createElement(
      "div",
      null,
      _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(_reactFormsProcessor.FormFragment, { defaultFields: _definitions.basicInfo })
      )
    )
  }, {
    label: "Options",
    content: _react2.default.createElement(
      "div",
      null,
      _react2.default.createElement(_reactFormsProcessor.FormFragment, { defaultFields: _definitions.optionsInfo })
    )
  }, {
    label: "Attributes",
    content: _react2.default.createElement(
      "div",
      null,
      _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(
          "div",
          null,
          _react2.default.createElement(_reactFormsProcessor.FormFragment, { defaultFields: _definitions.rulesInfo })
        )
      )
    )
  }, {
    label: "Validation",
    content: _react2.default.createElement(
      "div",
      null,
      _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(
          "div",
          null,
          _react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(_reactFormsProcessor.FormFragment, { defaultFields: _definitions.validationInfo })
          )
        )
      )
    )
  }, {
    label: "Advanced",
    content: _react2.default.createElement(
      "div",
      null,
      _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(
          "div",
          null,
          _react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              "div",
              null,
              _react2.default.createElement(_reactFormsProcessor.FormFragment, { defaultFields: _definitions.advancedInfo })
            )
          )
        )
      )
    )
  }];
};

var RepeatingFormField = function (_Component) {
  _inherits(RepeatingFormField, _Component);

  function RepeatingFormField(props) {
    _classCallCheck(this, RepeatingFormField);

    var _this = _possibleConstructorReturn(this, (RepeatingFormField.__proto__ || Object.getPrototypeOf(RepeatingFormField)).call(this, props));

    _this.state = {
      selectedTab: null
    };
    return _this;
  }

  _createClass(RepeatingFormField, [{
    key: "handleUpdate",
    value: function handleUpdate(selectedTab) {
      this.setState({ selectedTab: selectedTab.label });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          value = _props.value,
          id = _props.id;
      var selectedTab = this.state.selectedTab;

      return _react2.default.createElement(
        _reactFormsProcessor.FormContext.Consumer,
        null,
        function (context) {
          var renderer = context.renderer,
              optionsHandler = context.optionsHandler,
              onFieldChange = context.onFieldChange;

          return _react2.default.createElement(
            _reactFormsProcessor.Form,
            {
              value: value,
              parentContext: context,
              renderer: renderer,
              optionsHandler: optionsHandler,
              onChange: function onChange(value, isValid) {
                onFieldChange(id, value);
              }
            },
            _react2.default.createElement(_tabs2.default, {
              tabs: getTabs(renderer),
              onSelect: function onSelect(selectedTab) {
                return _this2.handleUpdate(selectedTab);
              },
              isSelectedTest: function isSelectedTest(selected, tab) {
                return selectedTab === tab.label;
              }
            })
          );
        }
      );
    }
  }]);

  return RepeatingFormField;
}(_react.Component);

exports.default = RepeatingFormField;